/* $OpenBSD: cipher.c,v 1.128 2026/05/31 04:37:56 djm Exp $ */
/*
 * Author: Tatu Ylonen <ylo@cs.hut.fi>
 * Copyright (c) 1995 Tatu Ylonen <ylo@cs.hut.fi>, Espoo, Finland
 *                    All rights reserved
 *
 * As far as I am concerned, the code I have written for this software
 * can be used freely for any purpose.  Any derived versions of this
 * software must be clearly marked as such, and if the derived work is
 * incompatible with the protocol description in the RFC file, it must be
 * called by a name other than "ssh" or "Secure Shell".
 *
 *
 * Copyright (c) 1999 Niels Provos.  All rights reserved.
 * Copyright (c) 1999, 2000 Markus Friedl.  All rights reserved.
 * Copyright (c) 2011-2026 Roumen Petrov.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "includes.h"

#include <sys/types.h>

#include <string.h>
#include <stdarg.h>
#include <stdio.h>

#include <openssl/evp.h>
#include <openssl/err.h>

#include "cipher.h"
#include "misc.h"
#include "xmalloc.h"
#include "log.h"
#include "sshbuf.h"
#include "ssherr.h"
#include "digest.h"

#ifdef WITH_OPENSSL

#ifdef ENABLE_KEY_PROVIDERS
extern OSSL_LIB_CTX *pkixssh_libctx;
extern char *pkixssh_propq;
#endif

#ifndef OPENSSL_HAVE_EVPCTR
const EVP_CIPHER *evp_aes_128_ctr(void);
void ssh_aes_ctr_iv(EVP_CIPHER_CTX *, int, u_char *, size_t);
# define EVP_aes_128_ctr evp_aes_128_ctr
# define EVP_aes_192_ctr evp_aes_128_ctr
# define EVP_aes_256_ctr evp_aes_128_ctr
# define NID_aes_128_ctr NID_undef
# define NID_aes_192_ctr NID_undef
# define NID_aes_256_ctr NID_undef
#endif

/* code that uses these is unreachable without GCM */
#if !defined(OPENSSL_HAVE_EVPGCM) && !defined(EVP_CTRL_GCM_SET_IV_FIXED)
# define EVP_CTRL_GCM_SET_IV_FIXED -1
# define EVP_CTRL_GCM_IV_GEN -1
# define EVP_CTRL_GCM_SET_TAG -1
# define EVP_CTRL_GCM_GET_TAG -1
#endif

#else /*ndef WITH_OPENSSL*/
# define EVP_CIPHER_CTX void
#endif


struct sshcipher_ctx {
	int	plaintext;
	int	encrypt;
	EVP_CIPHER_CTX *evp;
	struct chachapoly_ctx *cp_ctx;
	struct aesctr_ctx ac_ctx; /* XXX union with evp? */
	const struct sshcipher *cipher;
};

struct ssh_evp_st {
	const char *name;
	u_int nid; /* reserved */
	const EVP_CIPHER *(*type)(void); /* TODO: dynamic ? */
	int fips;
};
typedef struct ssh_evp_st ssh_evp;

struct sshcipher {
	const char	*name;
	u_int	block_size;
	u_int	key_len;
	u_int	iv_len;		/* defaults to block_size */
	u_int	auth_len;
	u_int	flags;
#define CFLAG_CBC		(1<<0)
#define CFLAG_CHACHAPOLY	(1<<1)
#define CFLAG_AESCTR		(1<<2)
#define CFLAG_NONE		(1<<3)
#define CFLAG_INTERNAL		CFLAG_NONE /* Don't use "none" for packets */
#ifdef WITH_OPENSSL
	ssh_evp	*ssh_evp;
#else
	void	*ignored;
#endif
};

static ssh_evp INFO_des_ede3_cbc = { "DES-EDE3-CBC", NID_des_ede3_cbc, EVP_des_ede3_cbc, -1 };
static ssh_evp INFO_aes_128_cbc = { "AES-128-CBC", NID_aes_128_cbc, EVP_aes_128_cbc, -1 };
static ssh_evp INFO_aes_192_cbc = { "AES-192-CBC", NID_aes_192_cbc, EVP_aes_192_cbc, -1 };
static ssh_evp INFO_aes_256_cbc = { "AES-256-CBC", NID_aes_256_cbc, EVP_aes_256_cbc, -1 };
static ssh_evp INFO_aes_128_ctr = { "AES-128-CTR", NID_aes_128_ctr, EVP_aes_128_ctr, -1 };
static ssh_evp INFO_aes_192_ctr = { "AES-192-CTR", NID_aes_192_ctr, EVP_aes_192_ctr, -1 };
static ssh_evp INFO_aes_256_ctr = { "AES-256-CTR", NID_aes_256_ctr, EVP_aes_256_ctr, -1 };
#ifdef OPENSSL_HAVE_EVPGCM
static ssh_evp INFO_aes_128_gcm = { "AES-128-GCM", NID_aes_128_gcm, EVP_aes_128_gcm, -1 };
static ssh_evp INFO_aes_256_gcm = { "AES-256-GCM", NID_aes_256_gcm, EVP_aes_256_gcm, -1 };
#endif

static const struct sshcipher ciphers[] = {
#ifdef WITH_OPENSSL
# ifndef OPENSSL_NO_DES
	{ "3des-cbc",		8, 24, 0, 0, CFLAG_CBC, &INFO_des_ede3_cbc },
# endif
	{ "aes128-cbc",		16, 16, 0, 0, CFLAG_CBC, &INFO_aes_128_cbc },
	{ "aes192-cbc",		16, 24, 0, 0, CFLAG_CBC, &INFO_aes_192_cbc },
	{ "aes256-cbc",		16, 32, 0, 0, CFLAG_CBC, &INFO_aes_256_cbc },
	{ "aes128-ctr",		16, 16, 0, 0, 0, &INFO_aes_128_ctr },
	{ "aes192-ctr",		16, 24, 0, 0, 0, &INFO_aes_192_ctr },
	{ "aes256-ctr",		16, 32, 0, 0, 0, &INFO_aes_256_ctr },
# ifdef OPENSSL_HAVE_EVPGCM
	{ "aes128-gcm@openssh.com",
				16, 16, 12, 16, 0, &INFO_aes_128_gcm },
	{ "aes256-gcm@openssh.com",
				16, 32, 12, 16, 0, &INFO_aes_256_gcm },
# endif /* OPENSSL_HAVE_EVPGCM */
#else
	{ "aes128-ctr",		16, 16, 0, 0, CFLAG_AESCTR, NULL },
	{ "aes192-ctr",		16, 24, 0, 0, CFLAG_AESCTR, NULL },
	{ "aes256-ctr",		16, 32, 0, 0, CFLAG_AESCTR, NULL },
#endif
#ifdef ENABLE_ETM_ALGORITHMS
	{ "chacha20-poly1305@openssh.com",
				8, 64, 0, 16, CFLAG_CHACHAPOLY, NULL },
#endif
	{ "none",		8, 0, 0, 0, CFLAG_NONE, NULL },

	{ NULL,			0, 0, 0, 0, 0, NULL }
};

/*--*/

#ifdef ENABLE_KEY_PROVIDERS
static int/*boolean*/
ssh_cipher_available(const char *algorithm) {
	int ret;
	EVP_CIPHER *cipher;

	ERR_set_mark();
	cipher = EVP_CIPHER_fetch(pkixssh_libctx, algorithm, pkixssh_propq);
	/* clear needless errors for unsupported algorithms */
	ERR_pop_to_mark();
	ret = (cipher != NULL) ? 1 : 0;
	EVP_CIPHER_free(cipher);

	return ret;
}

static int/*boolean*/
ssh_chacha20_available(void) {
	static int flag = -1;
	if (flag >= 0) return flag;

	flag = ssh_cipher_available("ChaCha20");
	return flag;
}
#endif

static inline int/*bool*/
cipher_allowed(const struct sshcipher *c) {
#ifdef HAVE_FIPS_MODULE
	ssh_evp *evp = c->ssh_evp;
#ifdef ENABLE_KEY_PROVIDERS
	if (evp != NULL) {
		if (evp->fips != -1) return evp->fips;
		switch (evp->nid) {
		case NID_des_ede3_cbc: {
			/* OpenSSL FIPS provider offers DES-EDE3-CBC but operations fail =>
			 * unconditionally exclude cipher.
			 */
			evp->fips = !ssh_is_fips_provider();
			return evp->fips;
			} break; /*unreachable*/
		}
	} else if (c->flags & CFLAG_CHACHAPOLY)
		return ssh_chacha20_available();
#endif
	if (c->flags & CFLAG_NONE) /* used in custom format */
		return 1;
	if (ssh_is_fips_enabled()) {
		if (evp == NULL) return 0;
		if (evp->fips != -1) return evp->fips;
	/* The FIPS flag has no effect for providers */
	#ifdef ENABLE_KEY_PROVIDERS
		evp->fips = ssh_cipher_available(evp->name);
	#else
	{	const EVP_CIPHER *cipher = evp->type();
		evp->fips = (EVP_CIPHER_flags(cipher) & EVP_CIPH_FLAG_FIPS) ? 1 : 0;
	}
	#endif
		return evp->fips;
	}
#else /*ndef HAVE_FIPS_MODULE*/
	UNUSED(c);
#endif /*ndef HAVE_FIPS_MODULE*/
	return 1;
}

/* Returns a comma-separated list of supported ciphers. */
char *
cipher_alg_list(char sep, int auth_only)
{
	char *ret = NULL;
	const struct sshcipher *c;
	char sep_str[2] = {sep, '\0'};

	for (c = ciphers; c->name != NULL; c++) {
		if ((c->flags & CFLAG_INTERNAL) != 0)
			continue;
		if (auth_only && c->auth_len == 0)
			continue;
		if (!cipher_allowed(c))
			continue;
		xextendf(&ret, sep_str, "%s", c->name);
	}
	if (ret == NULL)
		return xstrdup("");
	return ret;
}

const char *
compression_alg_list(int compression)
{
#ifdef WITH_ZLIB
	return compression ? "zlib@openssh.com,zlib,none" :
	    "none,zlib@openssh.com,zlib";
#else
	UNUSED(compression);
	return "none";
#endif
}

u_int
cipher_blocksize(const struct sshcipher *c)
{
	return (c->block_size);
}

u_int
cipher_keylen(const struct sshcipher *c)
{
	return (c->key_len);
}

u_int
cipher_seclen(const struct sshcipher *c)
{
	if (strcmp("3des-cbc", c->name) == 0)
		return 14;
	return cipher_keylen(c);
}

u_int
cipher_authlen(const struct sshcipher *c)
{
	return (c->auth_len);
}

u_int
cipher_ivlen(const struct sshcipher *c)
{
	/*
	 * Default is cipher block size, except for chacha20+poly1305 that
	 * needs no IV. XXX make iv_len == -1 default?
	 */
	return (c->iv_len != 0 || (c->flags & CFLAG_CHACHAPOLY) != 0) ?
	    c->iv_len : c->block_size;
}

u_int
cipher_is_cbc(const struct sshcipher *c)
{
	return (c->flags & CFLAG_CBC) != 0;
}

u_int
cipher_is_internal(const struct sshcipher *c)
{
	return (c->flags & CFLAG_INTERNAL) != 0;
}

u_int
cipher_ctx_is_plaintext(struct sshcipher_ctx *cc)
{
	return cc->plaintext;
}

/* NOTE: "none"-cipher is used in ssh_packet_set_connection()
 */
const struct sshcipher * cipher_none(void);

const struct sshcipher *
cipher_none(void)
{
	const struct sshcipher *c;
	for (c = ciphers; c->name != NULL; c++)
		if (c->flags & CFLAG_NONE)
			return c;
	return NULL;
}

const struct sshcipher *
cipher_by_name(const char *name)
{
	const struct sshcipher *c;

	if (name == NULL || *name == '\0') return NULL;

	for (c = ciphers; c->name != NULL; c++)
		if (strcmp(c->name, name) == 0)
		{
			if (!cipher_allowed(c))
				continue;
			return c;
		}
	return NULL;
}

#define	CIPHER_SEP	","
int
ciphers_valid(const char *names)
{
	const struct sshcipher *c;
	char *cipher_list, *cp;
	char *p;

	if (names == NULL || strcmp(names, "") == 0)
		return 0;
	if ((cipher_list = cp = strdup(names)) == NULL)
		return 0;
	for ((p = strsep(&cp, CIPHER_SEP)); p != NULL;
	    (p = strsep(&cp, CIPHER_SEP))) {
		c = cipher_by_name(p);
		if (c == NULL || (c->flags & CFLAG_INTERNAL) != 0) {
			free(cipher_list);
			return 0;
		}
	}
	free(cipher_list);
	return 1;
}

const char *
cipher_warning_message(const struct sshcipher_ctx *cc)
{
	if (cc == NULL || cc->cipher == NULL)
		return NULL;
	/* XXX repurpose for CBC warning */
	return NULL;
}

int
cipher_init(struct sshcipher_ctx **ccp, const struct sshcipher *cipher,
    const u_char *key, u_int keylen, const u_char *iv, u_int ivlen,
    int do_encrypt)
{
	struct sshcipher_ctx *cc = NULL;
	int ret = SSH_ERR_INTERNAL_ERROR;
#ifdef WITH_OPENSSL
	const EVP_CIPHER *type;
	int klen;
#endif

	*ccp = NULL;
	if ((cc = calloc(1, sizeof(*cc))) == NULL)
		return SSH_ERR_ALLOC_FAIL;

	cc->plaintext = (cipher->flags & CFLAG_NONE) != 0;
	cc->encrypt = do_encrypt;

	if (keylen < cipher->key_len ||
	    (iv != NULL && ivlen < cipher_ivlen(cipher))) {
		ret = SSH_ERR_INVALID_ARGUMENT;
		goto out;
	}

	cc->cipher = cipher;
	if ((cc->cipher->flags & CFLAG_CHACHAPOLY) != 0) {
		cc->cp_ctx = chachapoly_new(key, keylen);
		ret = cc->cp_ctx != NULL ? 0 : SSH_ERR_ALLOC_FAIL;
		goto out;
	}
	if ((cc->cipher->flags & CFLAG_NONE) != 0) {
		ret = 0;
		goto out;
	}
#ifndef WITH_OPENSSL
	if ((cc->cipher->flags & CFLAG_AESCTR) != 0) {
		aesctr_keysetup(&cc->ac_ctx, key, 8 * keylen, 8 * ivlen);
		aesctr_ivsetup(&cc->ac_ctx, iv);
		ret = 0;
		goto out;
	}
	ret = SSH_ERR_INVALID_ARGUMENT;
	goto out;
#else /* WITH_OPENSSL */
{	ssh_evp *evp = cipher->ssh_evp;
	if (evp == NULL) {
		ret = SSH_ERR_INTERNAL_ERROR;
		goto out;
	}
	type = (*evp->type)();
}
	if ((cc->evp = EVP_CIPHER_CTX_new()) == NULL) {
		ret = SSH_ERR_ALLOC_FAIL;
		goto out;
	}
#ifndef BROKEN_EVP_CIPHERINIT
	if (EVP_CipherInit(cc->evp, type, NULL, (u_char *)iv,
#else
	if (EVP_CipherInit(cc->evp, type, key, (u_char *)iv,
#endif /*ndef BROKEN_EVP_CIPHERINIT*/
	    (do_encrypt == CIPHER_ENCRYPT)) == 0) {
		ret = SSH_ERR_LIBCRYPTO_ERROR;
		goto out;
	}
	if (cipher_authlen(cipher) &&
	    EVP_CIPHER_CTX_ctrl(cc->evp, EVP_CTRL_GCM_SET_IV_FIXED,
	        -1, (u_char *)iv) <= 0) {
		ret = SSH_ERR_LIBCRYPTO_ERROR;
		goto out;
	}
	klen = EVP_CIPHER_CTX_key_length(cc->evp);
	if (klen > 0 && keylen != (u_int)klen) {
		if (EVP_CIPHER_CTX_set_key_length(cc->evp, keylen) == 0) {
			ret = SSH_ERR_LIBCRYPTO_ERROR;
			goto out;
		}
	}
#ifndef BROKEN_EVP_CIPHERINIT
	if (EVP_CipherInit(cc->evp, NULL, (u_char *)key, NULL, -1) == 0) {
		ret = SSH_ERR_LIBCRYPTO_ERROR;
		goto out;
	}
#endif /*ndef BROKEN_EVP_CIPHERINIT*/

	ret = 0;
#endif /* WITH_OPENSSL */
 out:
	if (ret == 0) {
		/* success */
		*ccp = cc;
	} else {
		if (cc != NULL) {
#ifdef WITH_OPENSSL
			EVP_CIPHER_CTX_free(cc->evp);
			cc->evp = NULL;
#endif /* WITH_OPENSSL */
			freezero(cc, sizeof(*cc));
		}
	}
	return ret;
}

/*
 * cipher_crypt() operates as following:
 * Copy 'aadlen' bytes (without en/decryption) from 'src' to 'dest'.
 * These bytes are treated as additional authenticated data for
 * authenticated encryption modes.
 * En/Decrypt 'len' bytes at offset 'aadlen' from 'src' to 'dest'.
 * Use 'authlen' bytes at offset 'len'+'aadlen' as the authentication tag.
 * This tag is written on encryption and verified on decryption.
 * Both 'aadlen' and 'authlen' can be set to 0.
 */
int
cipher_crypt(struct sshcipher_ctx *cc, u_int seqnr, u_char *dest,
   const u_char *src, u_int len, u_int aadlen, u_int authlen)
{
	if ((cc->cipher->flags & CFLAG_CHACHAPOLY) != 0) {
		return chachapoly_crypt(cc->cp_ctx, seqnr, dest, src,
		    len, aadlen, authlen, cc->encrypt);
	}
	if ((cc->cipher->flags & CFLAG_NONE) != 0) {
		memcpy(dest, src, aadlen + len);
		return 0;
	}
#ifndef WITH_OPENSSL
	if ((cc->cipher->flags & CFLAG_AESCTR) != 0) {
		if (aadlen)
			memcpy(dest, src, aadlen);
		aesctr_encrypt_bytes(&cc->ac_ctx, src + aadlen,
		    dest + aadlen, len);
		return 0;
	}
	return SSH_ERR_INVALID_ARGUMENT;
#else
	if (authlen) {
		u_char lastiv[1];

		if (authlen != cipher_authlen(cc->cipher))
			return SSH_ERR_INVALID_ARGUMENT;
		/* increment IV */
		if (EVP_CIPHER_CTX_ctrl(cc->evp, EVP_CTRL_GCM_IV_GEN,
		    1, lastiv) <= 0)
			return SSH_ERR_LIBCRYPTO_ERROR;
		/* set tag on decryption */
		if (!cc->encrypt &&
		    EVP_CIPHER_CTX_ctrl(cc->evp, EVP_CTRL_GCM_SET_TAG,
		        authlen, (u_char *)src + aadlen + len) <= 0)
			return SSH_ERR_LIBCRYPTO_ERROR;
	}
	if (aadlen) {
		if (authlen &&
		    EVP_Cipher(cc->evp, NULL, (u_char *)src, aadlen) < 0)
			return SSH_ERR_LIBCRYPTO_ERROR;
		memcpy(dest, src, aadlen);
	}
	if (len % cc->cipher->block_size)
		return SSH_ERR_INVALID_ARGUMENT;
	if (EVP_Cipher(cc->evp, dest + aadlen, (u_char *)src + aadlen,
	    len) < 0)
		return SSH_ERR_LIBCRYPTO_ERROR;
	if (authlen) {
		/* compute tag (on encrypt) or verify tag (on decrypt) */
		if (EVP_Cipher(cc->evp, NULL, NULL, 0) < 0)
			return cc->encrypt ?
			    SSH_ERR_LIBCRYPTO_ERROR : SSH_ERR_MAC_INVALID;
		if (cc->encrypt &&
		    EVP_CIPHER_CTX_ctrl(cc->evp, EVP_CTRL_GCM_GET_TAG,
		        authlen, dest + aadlen + len) <= 0)
			return SSH_ERR_LIBCRYPTO_ERROR;
	}
	return 0;
#endif
}

/* Extract the packet length, including any decryption necessary beforehand */
int
cipher_get_length(struct sshcipher_ctx *cc, u_int *plenp, u_int seqnr,
    const u_char *cp, u_int len)
{
	if ((cc->cipher->flags & CFLAG_CHACHAPOLY) != 0)
		return chachapoly_get_length(cc->cp_ctx, plenp, seqnr,
		    cp, len);
	if (len < 4)
		return SSH_ERR_MESSAGE_INCOMPLETE;
	*plenp = PEEK_U32(cp);
	return 0;
}

void
cipher_free(struct sshcipher_ctx *cc)
{
	if (cc == NULL)
		return;
	if ((cc->cipher->flags & CFLAG_CHACHAPOLY) != 0) {
		chachapoly_free(cc->cp_ctx);
		cc->cp_ctx = NULL;
	} else if ((cc->cipher->flags & CFLAG_AESCTR) != 0)
		explicit_bzero(&cc->ac_ctx, sizeof(cc->ac_ctx));
#ifdef WITH_OPENSSL
	EVP_CIPHER_CTX_free(cc->evp);
	cc->evp = NULL;
#endif
	freezero(cc, sizeof(*cc));
}


static inline int
ssh_copy_iv(EVP_CIPHER_CTX *ctx, void *buf, size_t len) {
#ifdef HAVE_OPENSSL_VERSION_MAJOR	/* OpenSSL >= 3.0 */
/* EVP_CIPHER_CTX_get_updated_iv() is very specific OpenSSL 3+ function.
 * So there is no need to test for availability at configure time.
 */
	return EVP_CIPHER_CTX_get_updated_iv(ctx, buf, len);
#elif defined(HAVE_EVP_CIPHER_CTX_GET_IV) && defined(LIBRESSL_VERSION_NUMBER)
/* At some point of time was defined by OpenSSL but wrongly designed
 * to return initial IV. Who cares for initial IV?!?!
 */
	return EVP_CIPHER_CTX_get_iv(ctx, buf, len);
#else
/* Defined in OpenSSL 1.1, deprecated in 3.0 ?!?! */
#ifdef HAVE_EVP_CIPHER_CTX_IV
	memcpy(buf, EVP_CIPHER_CTX_iv(ctx), len);
#else
	memcpy(buf, ctx->iv, len);
#endif
	return 1;
#endif
}

int
cipher_get_keyiv(struct sshcipher_ctx *cc, u_char *iv, size_t len)
{
#ifdef WITH_OPENSSL
	const struct sshcipher *c = cc->cipher;
	int evplen;
#endif

	if ((cc->cipher->flags & CFLAG_CHACHAPOLY) != 0) {
		if (len != 0)
			return SSH_ERR_INVALID_ARGUMENT;
		return 0;
	}
	if ((cc->cipher->flags & CFLAG_AESCTR) != 0) {
		if (len != sizeof(cc->ac_ctx.ctr))
			return SSH_ERR_INVALID_ARGUMENT;
		memcpy(iv, cc->ac_ctx.ctr, len);
		return 0;
	}
	if ((cc->cipher->flags & CFLAG_NONE) != 0)
		return 0;

#ifdef WITH_OPENSSL
	evplen = EVP_CIPHER_CTX_iv_length(cc->evp);
	if (evplen == 0)
		return 0;
	if (evplen < 0)
		return SSH_ERR_LIBCRYPTO_ERROR;
	if ((size_t)evplen != len)
		return SSH_ERR_INVALID_ARGUMENT;
#ifndef OPENSSL_HAVE_EVPCTR
	if (c->ssh_evp != NULL &&
	    c->ssh_evp->type == evp_aes_128_ctr) {
		ssh_aes_ctr_iv(cc->evp, 0, iv, len);
		return 0;
	}
#endif
	if (cipher_authlen(c)) {
		if (EVP_CIPHER_CTX_ctrl(cc->evp, EVP_CTRL_GCM_IV_GEN,
		    evplen, iv) <= 0)
			return SSH_ERR_LIBCRYPTO_ERROR;
	} else
		if (ssh_copy_iv(cc->evp, iv, len) != 1)
			return SSH_ERR_INVALID_ARGUMENT;
#endif
	return 0;
}
